import pyb , time, array

bsize=37 ; bi=0 ; buf=array.array("I")  # segéd buffer a debughoz
for i in range(bsize):
    buf.append(0)
# az időzítések tartományként vannak meghatározva
LP=range(200,800) ; APP=range(7000,10000) ; ASP=range(1500,2500) ; ALP=range(3500,4500) ; protwidth=36
ert=None ; temp=humy=ch=0 ; elozo=time.ticks_us() ; up = False
# a module adat lába ide csatlakozik
rfpin = pyb.Pin('Y12', pyb.Pin.IN , pyb.Pin.PULL_NONE)
def f():
    global elozo,ert, rfpin, up
    up=rfpin()==1 
    ert = time.ticks_us() - elozo
    elozo=time.ticks_us()

T_SER = T_WRK = time.ticks_ms()
# az adat láb megszakításának beállítása az előbb megadott funkcióra, fel és lefutó ág is kell
ext = pyb.ExtInt(rfpin, pyb.ExtInt.IRQ_RISING_FALLING, pyb.Pin.PULL_NONE, lambda t: f() )
STEP_IDLE   = 0 ; STEP_SYNCED = 1 ; STEP_DATA   = 2 ; STEP_PRINT  = 3 ; step = STEP_IDLE
while True:
    if ert!=None:
        if not up:
            if ert not in LP:
                if step==STEP_SYNCED:
                    print("*NOSYNC",bi,ert)
                step=STEP_IDLE
        elif step==STEP_IDLE and ert in APP:
            bi=0 ; step=STEP_SYNCED ; print("SYNC")
        elif step==STEP_SYNCED:
            buf[bi]=ert ; bi+=1 
            if bi==protwidth: step=STEP_DATA
        if step==STEP_DATA:   
            s="" ; err=False
            for i in range(protwidth):
                if buf[i] in ASP: s+="0"
                elif buf[i] in ALP: s+="1"
                else:
                    s+="_"
                    err=True
            if not err:
                temp = int( s[16:28] ,2 ) 
                if (temp > 3840): temp -= 4096
                temp/=10
                humy = int( s[28:36] ,2 )
            else:
                print("ERR:" + s )
            step=STEP_IDLE
        ert=None
    
    if time.ticks_ms()-T_SER>1000: # másodpercenként kiírja ha van dekódolt adat
        T_SER=time.ticks_ms()
        if temp!=0:
            print("temp: %.1fC, humy: %d%%" % (temp, humy))
            print(s)
            temp=0
        print("*")
